namespace Ecng.Trading.Xaml
{
	using System.Windows.Input;

	/// <summary>
	///     <see cref="MarketDepthControl"/>.
	/// </summary>
	public enum MarketDepthControlActionTypes
	{
		/// <summary>
		///    .
		/// </summary>
		BuyLimit,

		/// <summary>
		///    .
		/// </summary>
		SellLimit,

		/// <summary>
		///   .
		/// </summary>
		CancelGroup,

		/// <summary>
		///    .
		/// </summary>
		BuyMarket,

		/// <summary>
		///    .
		/// </summary>
		SellMarket,
	}

	/// <summary>
	///    <see cref="MarketDepthControl"/>.
	/// </summary>
	public class MarketDepthControlAction
	{
		/// <summary>
		///  ,     .
		/// </summary>
		/// <param name="type"> .</param>
		/// <param name="key"> ,    .</param>
		public MarketDepthControlAction(MarketDepthControlActionTypes type, Key key)
			: this(type, key, ModifierKeys.None)
		{
		}

		/// <summary>
		///  ,     .
		/// </summary>
		/// <param name="type"> .</param>
		/// <param name="key"> ,    .</param>
		/// <param name="modifierKey">   (Ctrl, Alt  ..).</param>
		public MarketDepthControlAction(MarketDepthControlActionTypes type, Key key, ModifierKeys modifierKey)
		{
			this.Type = type;
			this.Key = key;
			this.ModifierKey = modifierKey;
		}

		/// <summary>
		///  ,    .
		/// </summary>
		/// <param name="type"> .</param>
		/// <param name="mouseAction"> ,    .</param>
		public MarketDepthControlAction(MarketDepthControlActionTypes type, MouseAction mouseAction)
			: this(type, mouseAction, ModifierKeys.None)
		{
		}

		/// <summary>
		///  ,    .
		/// </summary>
		/// <param name="type"> .</param>
		/// <param name="mouseAction"> ,    .</param>
		/// <param name="modifierKey">   (Ctrl, Alt  ..).</param>
		public MarketDepthControlAction(MarketDepthControlActionTypes type, MouseAction mouseAction, ModifierKeys modifierKey)
		{
			this.Type = type;
			this.MouseAction = mouseAction;
			this.ModifierKey = modifierKey;
		}

		/// <summary>
		///  .
		/// </summary>
		public MarketDepthControlActionTypes Type { get; private set; }

		/// <summary>
		///  ,    .    <see cref="System.Windows.Input.MouseAction.None"/>,
		///      .
		/// </summary>
		public MouseAction MouseAction { get; private set; }

		/// <summary>
		///  ,    .    <see cref="System.Windows.Input.Key.None"/>,
		///      .
		/// </summary>
		public Key Key { get; private set; }

		/// <summary>
		///    (Ctrl, Alt  ..).
		/// </summary>
		public ModifierKeys ModifierKey { get; private set; }

		internal InputBinding Binding { get; set; }
	}
}