﻿namespace Ecng.Trading.Xaml
{
	using System;
	using System.Windows.Controls;

	using Ecng.Common;
	using Ecng.Trading.BusinessEntities;

	/// <summary>
	/// Контрол для редактирования объекта класса <see cref="Unit"/>.
	/// </summary>
	public partial class UnitControl
	{
		/// <summary>
		/// Создать объект класса <see cref="UnitControl"/>.
		/// </summary>
		public UnitControl()
		{
			InitializeComponent();
			//this.Range = new Range<double>(double.MinValue, double.MaxValue);
		}

		/// <summary>
		/// Значение, которое необходимо редактировать визуально.
		/// </summary>
		public Unit Unit
		{
			get
			{
				return _unitText.Text.ToUnit(this.Security);
			}
			set
			{
				if (value == null)
					throw new ArgumentNullException("value");

				_unitText.Text = value.ToString();
			}
		}

		/// <summary>
		/// Информация об инструменте. Необходима для <see cref="Ecng.Trading.BusinessEntities.Unit.Security"/>.
		/// </summary>
		public Security Security { get; set; }

		/// <summary>
		/// Доступно ли редактирование.
		/// </summary>
		public bool IsUnitEnabled
		{
			get { return _unitText.IsReadOnly; }
			set { _unitText.IsReadOnly = value; }
		}

		/// <summary>
		/// Происходит при изменении значения <see cref="Unit"/>.
		/// </summary>
		public event EventHandler<EventArgs> UnitChanged;

		///// <summary>
		///// Диапазон допустимых значений.
		///// </summary>
		//public Range<double> Range { get; set; }

		//private void _showDlg_Click(object sender, RoutedEventArgs e)
		//{
		//    var dlg = new UnitWindow { Unit = this.Unit, Range = this.Range };

		//    if (dlg.ShowModal(this))
		//    {
		//        this.Unit = dlg.Unit;
		//        UnitChanged.SafeInvoke(this, EventArgs.Empty);
		//    }
		//}

		///// <summary>
		///// Invoked when an unhandled <see cref="E:System.Windows.UIElement.MouseLeftButtonUp"/> routed event reaches an element in its
		///// route that is derived from this class. Implement this method to add class handling for this event.
		///// </summary>
		///// <param name="e">The <see cref="T:System.Windows.Input.MouseButtonEventArgs"/> that contains the event data.
		///// The event data reports that the left mouse button was released.
		///// </param>
		//protected override void OnMouseLeftButtonUp(MouseButtonEventArgs e)
		//{
		//    base.OnMouseLeftButtonUp(e);
		//    _showDlg_Click(this, new RoutedEventArgs());
		//}

		private void _unitText_TextChanged(object sender, TextChangedEventArgs e)
		{
			UnitChanged.SafeInvoke(this, EventArgs.Empty);
		}
	}
}